#include <stdio.h>
#include <stdlib.h>

void usage(void)
{
  fprintf(stderr, "Usage: part <file> <parts>\n");
}

int main(int argc, char *argv[])
{
  int i;

  if (argc != 3)
  {
    usage();
    return EXIT_FAILURE;
  }

  int parts = atol(argv[2]);

  FILE *finput;

  finput = fopen(argv[1], "r");
  if (finput == NULL)
  {
    fprintf(stderr, "Unable to open \"%s\" for input\n", argv[1]);
    usage();
    return EXIT_FAILURE;
  }


  FILE *foutput[parts];

  for (i=0; i<parts; i++)
  {
     char strOut[1000];
     sprintf(strOut, "%s_%03d", argv[1], 1+i);

     foutput[i] = fopen(strOut, "w");
     if (foutput[i] == NULL)
     {
       fprintf(stderr, "Unable to open \"%s\" for input\n", strOut);
       return EXIT_FAILURE;
     }
  }

  long lineno = 0;

  while (1)
  {
    int c = fgetc(finput);
    if (c == EOF)
      break;

      fputc(c, foutput[lineno % parts]);

    if (c == '\n')
    {
      lineno++;
    }
  }
  return 0;
}

